import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:http/http.dart';

import '../../../models/hospital.dart';
import '../../../models/user.dart';
import '../../api_routes/urls.dart';

class HospitalsProvider extends ChangeNotifier {
  // number of items call in each request
  final pageItemNumber = 50;

  //reset provider data
  void reset() {
    _hospitals = null;
    _stateCode = null;
  }

  // state code of current request to defied error message
  // like 400 customer request failed
  // 500 service not available
  int? _stateCode;

  int? get stateCode => _stateCode;

  // true if there is next page in product list and false if not
  bool _nextPage = true;

  bool get nextPage => _nextPage;

  // contain user data
  // when user not login or register _user = null
  List<Hospital>? _hospitals;

  List<Hospital>? get hospitals => _hospitals;

  // when categories in-process _loading = true
  // done _loading = true
  // failed _loading = false
  bool? _loading;

  bool? get isLoading => _loading;

  set isLoading(bool? isLoading) {
    _loading = isLoading;
    notifyListeners();
  }

  /// return -2 if request in progress
  /// return -1 if error happen when sending request
  /// return state code if request complete may be 200, 404 or 403
  /// for more details check http state manager
  /// lib\controllers\http_status_manger\http_status_manger.dart
  Future<int> getHospitals({
    required String host,
    required User user,
    required String? title,
  }) async {
    if (_loading == true) {
      return -2;
    }
    _loading = true;
    notifyListeners();
    Response response;
    try {
      response = await get(
        Uri.parse(
          "${host + URLs.getHospitals}?page=${(_hospitals?.length ?? 0) ~/ pageItemNumber}${title == null || title.isEmpty ? "" : "&name=$title"}",
        ),
        headers: {"Content-Type": "application/json; charset=utf-8"},
      );
      _stateCode = response.statusCode;
      if (response.statusCode >= 200 && response.statusCode < 300) {
        // client's request was successfully received
        List categoriesListJson = json.decode(utf8.decode(response.bodyBytes));
        List<Hospital> page = categoriesListJson.map((category) => Hospital.fromJson(category)).toList();
        if (hospitals == null) _hospitals = [];

        _hospitals?.addAll(page);
        if (page.length >= pageItemNumber) {
          _nextPage = true;
        } else {
          _nextPage = false;
        }
      }
      _loading = false;
      notifyListeners();
      return response.statusCode;
    } catch (error) {
      _loading = false;
      _stateCode = -1;
      notifyListeners();
      return -1;
    }
  }

  Future<List<Hospital>> getHospitalsList({
    required String host,
    required User user,
    required String title,
  }) async {
    Response response;
    try {
      response = await get(
        Uri.parse(
          host + URLs.getHospitals + (title.isEmpty ? "" : "?name=$title"),
        ),
        headers: {"Content-Type": "application/json; charset=utf-8"},
      );
      _stateCode = response.statusCode;

      List<Hospital> page = [];
      if (response.statusCode >= 200 && response.statusCode < 300) {
        // client's request was successfully received
        List categoriesListJson = json.decode(utf8.decode(response.bodyBytes));
        page = categoriesListJson.map((category) => Hospital.fromJson(category)).toList();
      }
      return page;
    } catch (error) {
      _loading = false;
      _stateCode = -1;
      notifyListeners();
      return [];
    }
  }
}
